/*
colors.js

Copyright (c) 2010

Marak Squires
Alexis Sellier (cloudhead)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/function stylize(e,t){var n;if(exports.mode==="console")n={bold:["[1m","[22m"],italic:["[3m","[23m"],underline:["[4m","[24m"],inverse:["[7m","[27m"],strikethrough:["[9m","[29m"],white:["[37m","[39m"],grey:["[90m","[39m"],black:["[30m","[39m"],blue:["[34m","[39m"],cyan:["[36m","[39m"],green:["[32m","[39m"],magenta:["[35m","[39m"],red:["[31m","[39m"],yellow:["[33m","[39m"],whiteBG:["[47m","[49m"],greyBG:["[49;5;8m","[49m"],blackBG:["[40m","[49m"],blueBG:["[44m","[49m"],cyanBG:["[46m","[49m"],greenBG:["[42m","[49m"],magentaBG:["[45m","[49m"],redBG:["[41m","[49m"],yellowBG:["[43m","[49m"]};else if(exports.mode==="browser")n={bold:["<b>","</b>"],italic:["<i>","</i>"],underline:["<u>","</u>"],inverse:['<span style="background-color:black;color:white;">',"</span>"],strikethrough:["<del>","</del>"],white:['<span style="color:white;">',"</span>"],grey:['<span style="color:gray;">',"</span>"],black:['<span style="color:black;">',"</span>"],blue:['<span style="color:blue;">',"</span>"],cyan:['<span style="color:cyan;">',"</span>"],green:['<span style="color:green;">',"</span>"],magenta:['<span style="color:magenta;">',"</span>"],red:['<span style="color:red;">',"</span>"],yellow:['<span style="color:yellow;">',"</span>"],whiteBG:['<span style="background-color:white;">',"</span>"],greyBG:['<span style="background-color:gray;">',"</span>"],blackBG:['<span style="background-color:black;">',"</span>"],blueBG:['<span style="background-color:blue;">',"</span>"],cyanBG:['<span style="background-color:cyan;">',"</span>"],greenBG:['<span style="background-color:green;">',"</span>"],magentaBG:['<span style="background-color:magenta;">',"</span>"],redBG:['<span style="background-color:red;">',"</span>"],yellowBG:['<span style="background-color:yellow;">',"</span>"]};else{if(exports.mode==="none")return e+"";console.log('unsupported mode, try "browser", "console" or "none"')}return n[t][0]+e+n[t][1]}function applyTheme(e){var t=["__defineGetter__","__defineSetter__","__lookupGetter__","__lookupSetter__","charAt","constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf","charCodeAt","indexOf","lastIndexof","length","localeCompare","match","replace","search","slice","split","substring","toLocaleLowerCase","toLocaleUpperCase","toLowerCase","toUpperCase","trim","trimLeft","trimRight"];Object.keys(e).forEach(function(n){t.indexOf(n)!==-1?console.log("warn: ".red+("String.prototype"+n).magenta+" is probably something you don't want to override. Ignoring style name"):typeof e[n]=="string"?addProperty(n,function(){return exports[e[n]](this)}):addProperty(n,function(){var t=this;for(var r=0;r<e[n].length;r++)t=exports[e[n][r]](t);return t})})}function sequencer(e){return function(){if(!isHeadless)return this.replace(/( )/,"$1");var t=this.split(""),n=0;return t=t.map(e),t.join("")}}function zalgo(e,t){function s(e){var t=Math.floor(Math.random()*e);return t}function o(e){var t=!1;return r.filter(function(n){t=n===e}),t}function u(e,t){var r="",i,u;t=t||{},t.up=t.up||!0,t.mid=t.mid||!0,t.down=t.down||!0,t.size=t.size||"maxi",e=e.split("");for(u in e){if(o(u))continue;r+=e[u],i={up:0,down:0,mid:0};switch(t.size){case"mini":i.up=s(8),i.min=s(2),i.down=s(8);break;case"maxi":i.up=s(16)+3,i.min=s(4)+1,i.down=s(64)+3;break;default:i.up=s(8)+1,i.mid=s(6)/2,i.down=s(8)+1}var a=["up","mid","down"];for(var f in a){var l=a[f];for(var c=0;c<=i[l];c++)t[l]&&(r+=n[l][s(n[l].length)])}}return r}var n={up:["̍","̎","̄","̅","̿","̑","̆","̐","͒","͗","͑","̇","̈","̊","͂","̓","̈","͊","͋","͌","̃","̂","̌","͐","̀","́","̋","̏","̒","̓","̔","̽","̉","ͣ","ͤ","ͥ","ͦ","ͧ","ͨ","ͩ","ͪ","ͫ","ͬ","ͭ","ͮ","ͯ","̾","͛","͆","̚"],down:["̖","̗","̘","̙","̜","̝","̞","̟","̠","̤","̥","̦","̩","̪","̫","̬","̭","̮","̯","̰","̱","̲","̳","̹","̺","̻","̼","ͅ","͇","͈","͉","͍","͎","͓","͔","͕","͖","͙","͚","̣"],mid:["̕","̛","̀","́","͘","̡","̢","̧","̨","̴","̵","̶","͜","͝","͞","͟","͠","͢","̸","̷","͡"," ҉"]},r=[].concat(n.up,n.down,n.mid),i={};return u(e)}var isHeadless=!1;typeof module!="undefined"&&(isHeadless=!0);if(!isHeadless){var exports={},module={},colors=exports;exports.mode="browser"}else exports.mode="console";var addProperty=function(e,t){exports[e]=function(e){return t.apply(e)},String.prototype.__defineGetter__(e,t)},x=["bold","underline","strikethrough","italic","inverse","grey","black","yellow","red","green","blue","white","cyan","magenta","greyBG","blackBG","yellowBG","redBG","greenBG","blueBG","whiteBG","cyanBG","magentaBG"];x.forEach(function(e){addProperty(e,function(){return stylize(this,e)})});var rainbowMap=function(){var e=["red","yellow","green","blue","magenta"];return function(t,n,r){return t===" "?t:stylize(t,e[n++%e.length])}}();exports.themes={},exports.addSequencer=function(e,t){addProperty(e,sequencer(t))},exports.addSequencer("rainbow",rainbowMap),exports.addSequencer("zebra",function(e,t,n){return t%2===0?e:e.inverse}),exports.setTheme=function(e){if(typeof e=="string")try{return exports.themes[e]=require(e),applyTheme(exports.themes[e]),exports.themes[e]}catch(t){return console.log(t),t}else applyTheme(e)},addProperty("stripColors",function(){return(""+this).replace(/\x1B\[\d+m/g,"")}),addProperty("zalgo",function(){return zalgo(this)});